#include <18F458.h>
//#device ADC=8
#fuses HS,NOWDT,NOPROTECT, NOBROWNOUT, NOLVP, NOPUT, NOWRT
#use delay(clock=4000000)
#use rs232(baud=9600,xmit=PIN_C6,rcv=PIN_C7) 

#define GLCD_WIDTH   128
#define FAST_GLCD

//#define ONE_WIRE_PIN PIN_A4
#define fartusu  !input(PIN_B4)
#define modtusu  !input(PIN_B1)
#define arttusu  !input(PIN_B2)
#define azttusu  !input(PIN_B5)
#define TONE_PIN   PIN_E0

//#define farduzey 100


#define KIS 0
#define UZU 1


#rom 0xF00000={0,0,0,0,0,0,0,0,40,0,0,8,0x89}  //eeprom bellekteki ilk deerler ( son 4 bellek gz, teker evresi deeri)


#define GLCD_CS1     PIN_A0   // Chip Selection 1
#define GLCD_CS2     PIN_A1   // Chip Selection 2
#define GLCD_DI      PIN_A2   // Data or Instruction input
#define GLCD_RW      PIN_A4   // Read/Write
#define GLCD_E       PIN_A5   // Enable

#include <HDM64GS12.c>
#include <graphics.c>                                 //pembegln lastikler 622 ye 37 =>  ( 622 + 37 + 37 ) * pi = 2185


//#include "DS1822.C"
#include "1wire.C"
#include "ds1307.c" 
//#include "hello_converted.c"
#include "splashscreen.h"


int yuzbinler, onbinler, binler, yuzler, onlar, birler, ondabirler;

float speed, eskispeed, maxspeed, avgspeed ;

//int  volt0;
//int16 olaysay;

int32 toplamkm, tripkm, tekercevresi, eskikm;

  BYTE sec; 
  BYTE min; 
  BYTE hrs; 
  BYTE day; 
  BYTE month; 
  BYTE yr; 
  BYTE dow; 

//   define
//==========================================================================

//-------------------------{}----------------------------

#priority CCP1, TIMER1 , ext1

#define BytePtr(var, offset) (char *)((char*)&var + offset) 

#byte PIR1 = 0x0C 
#bit  TMR1IF = PIR1.0 

int8  gc_timer1_extension = 0; 
int8  gc_capture_flag = FALSE; 
int32 g32_ccp_delta; 



//------------------------------------------------------ 
#int_timer1 
void timer1_isr(void) 
{ 
gc_timer1_extension++; 
} 

//------------------------------------------------------ 

#int_ccp1 
void ccp1_isr(void) 
{ 
char timer_ext_copy; 
int32 current_ccp; 
static int32 old_ccp = 0; 

gc_capture_flag = TRUE;        

current_ccp = (int32)CCP_1;    

// Get local copy of the timer ext. 
timer_ext_copy = gc_timer1_extension; 


if(TMR1IF) 
  { 
   if(*BytePtr(current_ccp, 1) < 2)  // Was CCP captured after Timer1 wrapped? 
      timer_ext_copy++;  // If so, inc the copy of the timer ext. 

   // Since we know a timer interrupt is pending, let's just 
   // handle it here and now.  That saves a little load off 
   // the processor. 
   gc_timer1_extension++;  // Increment the real timer extension 
   TMR1IF = 0;     // Then clear the Timer1 interrupt 
  } 

// Insert the timer extension into the proper place in the 32-bit 
// CCP value. 
// ie.,  Insert it into location "EE" as follows: 0x00EEnnnn 
// (nnnn = the CCP). 
*BytePtr(current_ccp, 2) = timer_ext_copy; 

g32_ccp_delta = (current_ccp > old_ccp) ? current_ccp - old_ccp : current_ccp + (0x1000000 - old_ccp); 

// Save the current ccp value for next time. 
old_ccp = current_ccp; 

} 
//-------------------------{}----------------------------
#INT_EXT
void ext_isr(){

toplamkm = toplamkm + tekercevresi;
tripkm += tekercevresi;
//printf(" %lu mm\r", toplamkm );

}
//-------------------------{}----------------------------

void lcdbas(float temp, int uzun){
yuzbinler = 0;
onbinler = 0;
binler = 0;
yuzler = 0;
onlar =0 ;
birler = 0;
ondabirler = 0;

while (temp>=100000) {
   yuzbinler++;
   temp-=100000;
}

while (temp>=10000) {
   onbinler++;
   temp-=10000;
}

while (temp>=1000) {
   binler++;
   temp-=1000;
}

while (temp>=100) {
   yuzler++;
   temp-=100;
}

while (temp>=10) {
   onlar++;
   temp-=10;
}

while (temp>=1) {
   birler++;
   temp-=1;
}
while (temp>=0.1) {
   ondabirler++;
   temp-=0.1;
}


/*
if( uzun == 1) Lcd_putc( 48 + yuzbinler); 
if( uzun == 1) Lcd_putc( 48 + onbinler); 
if( uzun == 1) Lcd_putc( 48 + binler); 
if( uzun == 1) Lcd_putc( 48 + yuzler); 
Lcd_putc( 48 + onlar); 
if( uzun == 1 ) Lcd_putc("."); 
Lcd_putc( 48 + birler);
if( uzun == 2 ) Lcd_putc("."); 
if ( uzun == 2 ) Lcd_putc( 48 + ondabirler);
*/
}
//-------------------------{}----------------------------
void beep(int16 period){

   while((period--) != 0)
   {
      output_high(TONE_PIN);
      delay_ms(2);
      output_low(TONE_PIN);
      delay_ms(2);
   }
}
//-------------------------{}----------------------------
void ayar(){

int ayarmod;


ayarmod = 1;
//lcd_putc("\f");

ds1307_get_date(day,month,yr,dow); 
ds1307_get_time(hrs,min,sec); 

basadon:
//lcd_gotoxy(1,1);
//lcd_putc("AYAR :   ");
while(modtusu);
//if(ayarmod == 1) lcd_putc(" >");
//else lcd_putc("  ");
lcdbas(hrs, KIS);
//if(ayarmod == 2) lcd_putc(">");
//else lcd_putc(" ");
lcdbas(min, KIS);

//lcd_gotoxy(1,2);

//if(ayarmod == 3) lcd_putc(">");
//else lcd_putc(" ");

lcdbas(day, KIS);

//if(ayarmod == 4) lcd_putc(" >");
//else lcd_putc("  ");

lcdbas(month, KIS);
//if(ayarmod == 5) lcd_putc(" >");
//else lcd_putc("  ");
lcdbas(yr, KIS);
//if(ayarmod == 6) lcd_putc(" >");
//else lcd_putc("  ");
      
      switch(dow){
            case 1:
            //lcd_putc("Pa");   
            break;
            case 2:
            //lcd_putc("Pt");   
            break;
            case 3:
            //lcd_putc("Sa");   
            break;
            case 4:
            //lcd_putc("Ca");   
            break;
            case 5:
            //lcd_putc("Pe");   
            break;
            case 6:
            //lcd_putc("Cu");   
            break;
            case 7:
            //lcd_putc("Ct");   
            break;
      }

if(ayarmod == 7) { 
   //lcd_putc("\f  Teker Cevresi");
   //lcd_putc("\n     ");
   lcdbas(tekercevresi, UZU);
   //lcd_putc(" cm");
}



while (TRUE){

   if(modtusu) {
      beep(10);
   while(modtusu);
      ayarmod ++;
      if (ayarmod == 8 ) {
         //lcd_putc("\f");   
         ds1307_set_date_time(day,month,yr, dow,hrs,min,0); 
         return;
      }
      goto basadon;
   }
   if(arttusu) {
   while (arttusu);
   //printf("Art basildi, mod : %d \r\n", ayarmod );
      switch(ayarmod){
            case 1:
               hrs ++;
               if ( hrs >= 24 ) hrs = 0;
            break;
            case 2:
               min ++;
               if ( min >= 60 ) min = 0;
            break;
            case 3:
               day ++;
               if ( day >= 32 ) day = 0;
            break;
            case 4:
               month ++;
               if ( month >= 13 ) month = 1;
            break;
            case 5:
               yr ++;
            break;
            case 6:
               dow ++;
               if ( dow >= 8 ) dow = 1;
            break;
            case 7:
               if ( tekercevresi  < 9999 ) tekercevresi++;              
            break;
      }
      goto basadon;
   }
   
   if(azttusu) {
   while (azttusu);
   //printf("Azt basildi, mod : %d \r\n", ayarmod );
      switch(ayarmod){
            case 1:
               hrs --;
               if ( hrs == 255 ) hrs = 23;
            break;
            case 2:
               min --;
               if ( min == 255 ) min = 59;
            break;
            case 3:
               day --;
               if ( day == 255 ) day = 31;
            break;
            case 4:
               month --;
               if ( month == 0 ) month = 12;
            break;
            case 5:
               yr --;
            break;
            case 6:
               dow --;
               if ( dow == 0 ) dow = 7;
            break;
            case 7:
               if ( tekercevresi  > 0 ) tekercevresi--;
            break;
      }
      goto basadon;
   }
}
}
//-------------------------{}----------------------------

void tekercevyaz(){

int32 depo;

depo = tekercevresi;

write_eeprom( 9 , ((depo>>24) & 0x00FF));
write_eeprom( 10, ((depo>>16) & 0x00FF));
write_eeprom( 11, ((depo>>8 ) & 0x00FF));
write_eeprom( 12, ((depo    ) & 0x00FF));

}
//-------------------------{}----------------------------
void splashscreen(int xs, int ys)
{

int i, j, k;
int16 sayac2=0 ;

int width = 128;
int height = 64;
for(i=0;i<height;i+=8) {
   for(j=0;j<width;j++) {
      for(k=0;k<8;k++) 
      { 
            if(bit_test(bikesplash[sayac2],k)){
               glcd_pixel(xs+j,ys+i+k,ON); 
               }
      }
      sayac2++;
   }
}
}
//-------------------------{}----------------------------
void kmyaz(){

int32 depo;

depo = toplamkm;

write_eeprom(0, ((depo>>24) & 0x00FF));
write_eeprom(1, ((depo>>16) & 0x00FF));
write_eeprom(2, ((depo>>8 ) & 0x00FF));
write_eeprom(3, ((depo    ) & 0x00FF));

depo = tripkm;

write_eeprom(4, ((depo>>24) & 0x00FF));
write_eeprom(5, ((depo>>16) & 0x00FF));
write_eeprom(6, ((depo>>8 ) & 0x00FF));
write_eeprom(7, ((depo    ) & 0x00FF));
}


//-------------------------{}----------------------------
void rakambas(int x, int y, float rakam, int boy){
char  rakamlar[] = "00000";
  
  sprintf(rakamlar,"%4.2f",(float) rakam); 

glcd_text57(x, y, rakamlar , boy, ON);
}


//   main function               (main function of the program)
//==========================================================================
void main(void)
{

float frequency; 
int32 current_ccp_delta; 


int temperature,eskitemp; 
int1 eskisec;
int32 ekrankm,ekrankm2;

set_timer1(0);    
setup_timer_1(T1_INTERNAL | T1_DIV_BY_1);    
setup_ccp1(CCP_CAPTURE_RE);    

//SETUP_ADC_PORTS(AN0);
//setup_adc( ADC_CLOCK_INTERNAL );


printf("Start: OK\n\r");
//lcd_init();
beep(2);

   glcd_init (ON);
   splashscreen(0,0);
   glcd_update ();


ds1307_init(); 
  // Set date for -> 15 June 2005 Tuesday 
  // Set time for -> 15:20:55 

//ds1307_set_date_time(2,3,9,2,20,50,55); 

//lcd_putc("\f");
//lcd_putc("    PembeguL    ");
//lcd_putc("\n");
//lcd_putc("    KomPuter    ");
//hello();
delay_ms(100);
//lcd_putc("\f");

port_b_pullups(0b00001000);


toplamkm = 0;

toplamkm += read_eeprom( 0 );
toplamkm=toplamkm<<8;
toplamkm += read_eeprom( 1 );
toplamkm=toplamkm<<8;
toplamkm += read_eeprom( 2 );
toplamkm=toplamkm<<8;
toplamkm += read_eeprom( 3 );

tripkm = 0;

tripkm += read_eeprom( 4 );
tripkm=tripkm<<8;
tripkm += read_eeprom( 5 );
tripkm=tripkm<<8;
tripkm += read_eeprom( 6 );
tripkm=tripkm<<8;
tripkm += read_eeprom( 7 );

tekercevresi = 0;  

tekercevresi += read_eeprom( 18 );
tekercevresi = tekercevresi << 8 ;
tekercevresi += read_eeprom( 20 );
tekercevresi = tekercevresi << 8 ;
tekercevresi += read_eeprom( 22 );
tekercevresi = tekercevresi << 8 ;
tekercevresi += read_eeprom( 24 );

//tekercevresi = 2100;  
//olaysay = 5;
maxspeed = 0 ;
eskispeed = 0 ;

//if ((fargucu & 0x0f) != 0 ) fargucu = 30;

// Enable interrupts. 
clear_interrupt(INT_TIMER1); 
enable_interrupts(INT_TIMER1); 

clear_interrupt(INT_CCP1); 
enable_interrupts(INT_CCP1); 

clear_interrupt(INT_EXT); 
enable_interrupts(INT_EXT);

enable_interrupts(GLOBAL); 


while(TRUE) 
 { 
 
 glcd_fillScreen(0);
 
  if(gc_capture_flag == TRUE) 
     { 
      disable_interrupts(GLOBAL); 
      current_ccp_delta = g32_ccp_delta;; 
      enable_interrupts(GLOBAL); 

      frequency =  (1000000L / (float)current_ccp_delta); 
      speed = 3.6*2.3*frequency;
      
      if ( speed != eskispeed ){
      
      rakambas(48,20, speed,3);
      glcd_update();
      
      }      
      
      if ( speed > 99 ) {
         beep (1);
         speed = eskispeed;
      }
      else eskispeed = speed;
      

      
      printf("%4.2f  %4.2f\n\r", frequency,(float)speed); 
      
//      lcd_gotoxy(1,1);
//      lcdbas( 3.6*2.3*frequency , 0);


   

      gc_capture_flag = FALSE; 
     } 
  else 
    { 
     printf("No signal\n\r"); 
     speed = 0;
     
//      lcd_gotoxy(1,1);
//      lcdbas( 0 , 0);
    } 

//*********************************************
/*
if( volt0 < farduzey ){
   
   if ( karyon == 1 && karasimsek == 0b00000001) karyon = 0;
   if ( karyon == 0 && karasimsek == 0b10000000) karyon = 1;   
   if (karyon == 1) karasimsek = karasimsek >> 1;
   if (karyon == 0) karasimsek = karasimsek << 1;
   karasimled(); 
}
else karasimson();*/

if(modtusu) { 
   beep(10);
   ayar();
   }

if(arttusu && azttusu ) {
   beep(10);
   tripkm = 0;
   while (arttusu && azttusu );
}

if(arttusu) {
   beep(2);
   
//   while (arttusu);
}

if(azttusu) {
   beep(2);
//   while (azttusu);
}

//lcd_gotoxy(1,1);




//lcdbas( speed , 2);

//if (speed > maxspeed ) maxspeed = speed;

//lcd_gotoxy(1,2);
//rakambas(0,50, maxspeed,2);
//lcdbas( maxspeed , 2);

//lcd_gotoxy(6,2);
//lcdbas( avgspeed , 0);
//rakambas(80,50, avgspeed,2);

//lcd_gotoxy(10,1);
//ekrankm = toplamkm/100000;
//lcdbas( ekrankm , 1);
//rakambas(1,0, ekrankm,2);
/*if (ekrankm != eskikm) {
   kmyaz();
   eskikm = ekrankm;
}
*/
//lcd_gotoxy(15,2);
/*
ekrankm2 = tripkm/1000000;
lcdbas( ekrankm2 , 0);
rakambas(1,25, ekrankm2,2);*/
//printf("Toplam mm : %lu \r\n", toplamkm );


/*olaysay--;
if( olaysay == 0 ){
   olaysay = 10;
   set_adc_channel( 0 );
   volt0 = read_adc();
//   if( volt0 < farduzey ) karastart = 1;
}*/
  
  //temperature = onewire_ds1822_read_temp_c_lite(); 
  //temperature = ds1820_read();
     
     
   //if( temperature != eskitemp) {
   //printf("Temp: %i\r", temperature);
   //eskitemp = temperature;
   //}
  
 
    /*ds1307_get_date(day,month,yr,dow); 
    ds1307_get_time(hrs,min,sec); 
      
    printf("\f\%02d/\%02d/\%02d\r\n",day,month,yr); 
    printf("\%02d:\%02d:\%02d", hrs,min,sec); 
   */

//lcd_gotoxy(6,1);
//rakambas(70,0, temperature,2);
//lcdbas(temperature, 0);
//lcd_putc("C");

//lcd_putc("%");
//lcdbas(fargucu, 0);

//lcd_gotoxy(9,2);

//lcdbas(hrs, 0);
//if ( bit_test( sec,0 ) != eskisec  ) { 
//   lcd_putc(":"); 
//   eskisec = bit_test( sec,0 );
//}
//else {
//   lcd_putc(" ");
//}

//lcdbas(min, 0);
//   lcd_putc(":"); 
//lcdbas(sec, 0);

//glcd_update();

delay_ms(200);
}



//*********************************************
  //delay_ms(500);
 }




////////////////////////////////////////////////////////




