#include <18F4580.h>
#device ADC=8
#fuses INTRC_IO,NOWDT,NOPROTECT, NOBROWNOUT, NOLVP, PUT, NOWRT, MCLR
#use delay(clock=8000000)
//#use rs232(baud=9600,xmit=PIN_C6,rcv=PIN_C7) 
#use rs232(icd) 

#define GLCD_WIDTH   128
#define FAST_GLCD

#define fartusu  !input(PIN_B4)
#define modtusu  !input(PIN_B1)
#define arttusu  !input(PIN_B2)
#define azttusu  !input(PIN_B5)
#define TONE_PIN  PIN_E0
#define POWCON    PIN_C1

//#define KIS 0
//#define UZU 1


#rom 0xF00000={0,0,0,0,0,0,0,0,40,0,0,8,0x89}  //eeprom bellekteki ilk deerler ( son 4 bellek gz, teker evresi deeri)


#define GLCD_CS1     PIN_A3   // Chip Selection 1
#define GLCD_CS2     PIN_A1   // Chip Selection 2
#define GLCD_DI      PIN_A2   // Data or Instruction input
#define GLCD_RW      PIN_A4   // Read/Write
#define GLCD_E       PIN_A5   // Enable
#define GLCD_RST     PIN_C5   // Reset

#include <HDM64GS12.c>
#include <graphics_ozkal.c>                                 //pembegln lastikler 622 ye 37 =>  ( 622 + 37 + 37 ) * pi = 2185

#include "1wire.C"
#include "ds1307.c" 
//#include "hello_converted.c"
#include "splashscreen.h"

#include <math.h>


//int yuzbinler, onbinler, binler, yuzler, onlar, birler, ondabirler;
int pulsevar;
float temperature,eskitemp; 

float speed, eskispeed, maxspeed, avgspeed ;
float ekrankm,eskikm,ekrankm2,ekrankm3,ekrankm4;
float theta1 = 0, theta2=0, theta3=4, theta4=5,thetamax=0;

int maxtemp, mintemp;
int  batvolt;
//int16 olaysay;

int32 toplamm, tripmm1, tripmm2, tripmm3, tripmm4;
int16 tekercevresi;

int tripkmno=1;
int   ekrtip=1;
int1 pulsegeldi, tempsira, ilkokuma;

char kmh[]="km/h";
char kmk[]="k";
char kmm[]="m";
char derece[]=" C";
char max[]="max";
char time[]="ti";

int sec, min, hrs, day, month, yr, dow; 
  
int eskimin;

int16 tripmins;

//-------------------------{}----------------------------

#priority CCP1, TIMER1 , ext1

#define BytePtr(var, offset) (char *)((char*)&var + offset) 

#byte PIR1 = 0x0C 
#bit  TMR1IF = PIR1.0 

int8  gc_timer1_extension = 0; 
int8  gc_capture_flag = FALSE; 
int32 g32_ccp_delta; 



//------------------------------------------------------ 
#int_timer1 
void timer1_isr(void) 
{ 
gc_timer1_extension++; 
pulsevar++;
} 

//------------------------------------------------------ 

#int_ccp1 
void ccp1_isr(void) 
{ 
char timer_ext_copy; 
int32 current_ccp; 
static int32 old_ccp = 0; 

gc_capture_flag = TRUE;        

current_ccp = (int32)CCP_1;    

// Get local copy of the timer ext. 
timer_ext_copy = gc_timer1_extension; 


if(TMR1IF) 
  { 
   if(*BytePtr(current_ccp, 1) < 2){  // Was CCP captured after Timer1 wrapped? 
      timer_ext_copy++;  // If so, inc the copy of the timer ext. 
   }
   // Since we know a timer interrupt is pending, let's just // OZKAL bu alttaki iki satr iptal edince hz hesabndaki problem kalkt
   // handle it here and now.  That saves a little load off 
   // the processor. 
   //gc_timer1_extension++;  // Increment the real timer extension 
   //TMR1IF = 0;     // Then clear the Timer1 interrupt 
  } 

// Insert the timer extension into the proper place in the 32-bit 
// CCP value. 
// ie.,  Insert it into location "EE" as follows: 0x00EEnnnn 
// (nnnn = the CCP). 
*BytePtr(current_ccp, 2) = timer_ext_copy; 

g32_ccp_delta = (current_ccp > old_ccp) ? current_ccp - old_ccp : current_ccp + (0x1000000 - old_ccp); 

// Save the current ccp value for next time. 
old_ccp = current_ccp; 

} 
//-------------------------{}----------------------------
#INT_EXT
void ext_isr(){

toplamm += tekercevresi;
tripmm1   += tekercevresi;
tripmm2   += tekercevresi;
tripmm3   += tekercevresi;
tripmm4   += tekercevresi;
pulsegeldi=pulsegeldi^1;

}
//-------------------------{}----------------------------
void beep(int16 period){

   while((period--) != 0)
   {
      output_high(TONE_PIN);
      delay_ms(2);
      output_low(TONE_PIN);
      delay_ms(2);
   }
}
//-------------------------{}----------------------------
void bekle(int16 zaman){
while(zaman-->0)delay_ms(1);
}
//-------------------------{}----------------------------
void tekercevyaz(){

int32 depo;

depo = tekercevresi;

/*write_eeprom( 9 , ((depo>>24) & 0x00FF));
write_eeprom( 10, ((depo>>16) & 0x00FF));
write_eeprom( 11, ((depo>>8 ) & 0x00FF));
write_eeprom( 12, ((depo    ) & 0x00FF));
*/
write_eeprom( 18 , ((depo>>24) & 0x00FF));
write_eeprom( 20, ((depo>>16) & 0x00FF));
write_eeprom( 22, ((depo>>8 ) & 0x00FF));
write_eeprom( 24, ((depo    ) & 0x00FF));
}
//-------------------------{}----------------------------
void dash_avent(int xs, int ys)
{

int i, j, k;
int16 sayac2=0 ;

int width = 128;
int height = 64;
for(i=0;i<height;i+=8) {
   for(j=0;j<width;j++) {
      for(k=0;k<8;k++) 
      { 
            if(bit_test(dashavent[sayac2],k)){
               glcd_pixel(xs+j,ys+i+k,ON); 
               }
      }
      sayac2++;
   }
}
}
//-------------------------{}----------------------------
void dashciz(int xs, int ys)
{

int i, j, k;
int16 sayac2=0 ;

int width = 128;
int height = 64;
for(i=0;i<height;i+=8) {
   for(j=0;j<width;j++) {
      for(k=0;k<8;k++) 
      { 
            if(bit_test(dash[sayac2],k)){
               glcd_pixel(xs+j,ys+i+k,ON); 
               }
      }
      sayac2++;
   }
}
}
//-------------------------{}----------------------------
void splashscreen(int xs, int ys)
{

int i, j, k;
int16 sayac2=0 ;

int width = 128;
int height = 64;
for(i=0;i<height;i+=8) {
   for(j=0;j<width;j++) {
      for(k=0;k<8;k++) 
      { 
            if(bit_test(bikesplash[sayac2],k)){
               glcd_pixel(xs+j,ys+i+k,ON); 
               }
      }
      sayac2++;
   }
}
}
//-------------------------{}----------------------------
void kmyaz(){

int32 depo;

depo = toplamm;

write_eeprom(0, ((depo>>24) & 0x00FF));
write_eeprom(1, ((depo>>16) & 0x00FF));
write_eeprom(2, ((depo>>8 ) & 0x00FF));
write_eeprom(3, ((depo    ) & 0x00FF));

depo = tripmm1;

write_eeprom(4, ((depo>>24) & 0x00FF));
write_eeprom(5, ((depo>>16) & 0x00FF));
write_eeprom(6, ((depo>>8 ) & 0x00FF));
write_eeprom(7, ((depo    ) & 0x00FF));
}
//-------------------------{}----------------------------
void tambas(int x, int y, int rakam, int boy){
char  rakamlar[] = "000";
  
  sprintf(rakamlar,"%u", rakam); 

glcd_text57(x, y, rakamlar , boy, ON);
}
//-------------------------{}----------------------------
void tekerbas(int x, int y, int boy){
char  rakamlar[] = "00000";
  
  sprintf(rakamlar,"%Lu mm", (int32) tekercevresi); 

glcd_text57(x, y, rakamlar , boy, ON);
}
//-------------------------{}----------------------------
void saatbas(int x, int y, int boy){
char  rakamlar[] = "00000";
  
  sprintf(rakamlar,"%2u:%2u", hrs, min); 

glcd_text57(x, y, rakamlar , boy, ON);
}
//-------------------------{}----------------------------
void kmbas(int x, int y, int boy){
char  rakamlar[] = "0000000";

//printf("\%5.1f \r\n",  ekrankm);
sprintf(rakamlar,"%5.1f", ekrankm); 
//if(tripkmbas==1)  sprintf(rakamlar,"%5.2f", ekrankm); 
//else sprintf(rakamlar,"%6.2f",(float) ekrankm); 

glcd_text57(x, y, rakamlar , boy, ON);
}
//-------------------------{}----------------------------
void tarihbas(int x, int y, int boy){
char  rakamlar[] = "00000000";
  
  sprintf(rakamlar,"%2u %2u %2u", day, month, yr); 

glcd_text57(x, y, rakamlar , boy, ON);
}
//-------------------------{}----------------------------
void rakambas(int x, int y, float rakam, int boy){
char  rakamlar[] = "00000";
  
  sprintf(rakamlar,"%5.2f",(float) rakam); 

glcd_text57(x, y, rakamlar , boy, ON);
}
//-------------------------{}----------------------------
void rakambas1(int x, int y, float rakam, int boy){
char  rakamlar[] = "00000";
  
  sprintf(rakamlar,"%2.1f", rakam); 

glcd_text57(x, y, rakamlar , boy, ON);
}
//-------------------------{}----------------------------
void rakambas2(int x, int y, float rakam, int boy){
char  rakamlar[] = "0000000";
  
  sprintf(rakamlar,"%3.2f", rakam); 

glcd_text57(x, y, rakamlar , boy, ON);
}
//-------------------------{}----------------------------
void dowbas(int x, int y, int boy){
char  rakamlar[] = "000";

      switch(dow){
            case 1:
            sprintf( rakamlar,"Pa" ); 
            break;
            case 2:
            sprintf( rakamlar,"Pt" ); 
            break;
            case 3:
            sprintf( rakamlar,"Sa" ); 
            break;
            case 4:
            sprintf( rakamlar,"Ca" );  
            break;
            case 5:
            sprintf( rakamlar,"Pe" );  
            break;
            case 6:
            sprintf( rakamlar,"Cu" ); 
            break;
            case 7:
            sprintf( rakamlar,"Ct" );  
            break;
      }

glcd_text57(x, y, rakamlar , boy, ON);
}
//-------------------------{}----------------------------
void digitbas(int x, int y, float rakamdepo, int boy){
char  rakamlar[]=" ";
float bolen;
int basamak,carpan;


basamak=0;
//rakamdepo=rakam;
bolen=100000;
carpan=0;


while(bolen!=1){
   while(rakamdepo>=bolen){
   rakamdepo = rakamdepo - bolen;
   basamak = basamak + 1;
   }  
   bolen = bolen/10;
   sprintf(rakamlar,"%d",basamak);
   glcd_text57(x+6*carpan*boy, y, rakamlar , boy, ON);
   carpan++;
   basamak=0;
}   
basamak=(rakamdepo);
   sprintf(rakamlar,"%d",basamak);
   glcd_text57(x+6*carpan*boy, y, rakamlar , boy, ON);
   //glcd_pixel(x+6*carpan*boy-1, y+6,1);
}
//-------------------------{}----------------------------
void yazibas(int x, int y, char yazi, int boy){
char  metin[] = "      ";
  
  sprintf(metin,"%s", yazi); 

glcd_text57(x, y, *metin , boy, ON);
}
//-------------------------{}----------------------------
void minirakam(int x, int y, rakam)
{

      switch(rakam){
            case 0:
               glcd_rect(x,y,x+2,y+4,0,1);
            break;      
            case 1:
               glcd_line(x+1,y,x+1,y+4,1);
            break;
            case 2:
               glcd_rect(x,y,x+2,y+4,0,1);   
               glcd_pixel(x+1,y+2,1);  
               glcd_pixel(x,y+1,0);   
               glcd_pixel(x+2,y+3,0);   
            break;
            case 3:
               glcd_rect(x,y,x+2,y+4,0,1);   
               glcd_pixel(x+1,y+2,1); 
               glcd_pixel(x,y+1,0);   
               glcd_pixel(x,y+3,0);   
            break;
            case 4:
               glcd_rect(x,y,x+2,y+4,0,1);   
               glcd_pixel(x+1,y+2,1);
               glcd_pixel(x+1,y,0);
               glcd_pixel(x,y+3,0);
               glcd_pixel(x,y+4,0);
               glcd_pixel(x+1,y+4,0);
            break;
            case 5:
               glcd_rect(x,y,x+2,y+4,0,1);   
               glcd_pixel(x+1,y+2,1);  
               glcd_pixel(x+2,y+1,0);   
               glcd_pixel(x,y+3,0); 
            break;
            case 6:
               glcd_rect(x,y,x+2,y+4,0,1);   
               glcd_pixel(x+1,y+2,1);  
               glcd_pixel(x+2,y+1,0);               
            break;
            case 7:
               glcd_line(x,y,x+2,y,1);
               glcd_line(x+2,y,x+1,y+4,1);
            break;
            case 8:
               glcd_rect(x,y,x+2,y+4,0,1);   
               glcd_pixel(x+1,y+2,1);            
            break;
            case 9:
               glcd_rect(x,y,x+2,y+4,0,1);   
               glcd_pixel(x+1,y+2,1);  
               glcd_pixel(x,y+3,0);  
            break;            
      }

}
//-------------------------{}----------------------------
void minisayi2 (int x, int y, float rakam)
{
char  rakamlar[] = "0000000";
int basamak;
  
  sprintf(rakamlar,"%5.2f",  (float) rakam); 



for(basamak=0;basamak<4;basamak++){
  minirakam(x+4*basamak,y,rakamlar[basamak]);
}

//glcd_text57(x, y, rakamlar , 1, ON);
}
//-------------------------{}----------------------------
void minisayi (int x, int y, float sayi)
{
int basamak, rakam;
   rakam=0;
   basamak=0;
   while(sayi>=1000000){
      rakam++;
      sayi-= 1000000;
   }
   minirakam(x,y,rakam);
   basamak++;
   rakam=0;
   while(sayi>=100000){
      rakam++;
      sayi-= 100000;
   }
   minirakam(x+4*basamak,y,rakam);
   basamak++;
   rakam=0;
   while(sayi>=10000){
      rakam++;
      sayi-= 10000;
   }
   minirakam(x+4*basamak,y,rakam);
   basamak++;
   rakam=0;
   while(sayi>=1000){
      rakam++;
      sayi-= 1000;
   }
   minirakam(x+4*basamak,y,rakam);
   basamak++;
   rakam=0;
   while(sayi>=100){
      rakam++;
      sayi-= 100;
   }
   minirakam(x+4*basamak,y,rakam);
   basamak++;
   rakam=0;
   while(sayi>=10){
      rakam++;
      sayi-= 10;
   }
   minirakam(x+4*basamak,y,rakam);
   basamak++;
   rakam=0;
   while(sayi>=1){
      rakam++;
      sayi-= 1;
   }
   minirakam(x+4*basamak,y,rakam);
/*   glcd_pixel(x+4*basamak+4,y+4,1);
   basamak++;
   rakam=0;
   sayi= sayi*100;
   while(sayi>=10){
      rakam++;
      sayi-= 10;
   }
   minirakam(x+4*basamak+2,y,rakam);
   basamak++;
   rakam=0;
   while(sayi>=1){
      rakam++;
      sayi-= 1;
   }
   minirakam(x+4*basamak+2,y,rakam);
   basamak++;
*/
}
//-------------------------{}----------------------------
void dashdigi(){


rakambas( 16 , 21 , speed , 3 );
glcd_rect(14,19,96,43,0,1);
glcd_rect(96,19,122,29,0,1);
glcd_line(96,20,96,28,0);
glcd_text57(98, 21, kmh , 1, ON);

rakambas( 98 , 31 , maxspeed , 1 );
glcd_text57(110, 37, max , 1, ON);


saatbas( 72 , 47 , 2 );
glcd_rect(59,45,127,62,0,1);
//glcd_rect(107,37,127,45,0,1);
//glcd_line(108,45,126,45,0);
dowbas(61, 50, 1 );



rakambas(2,47, temperature,2);
glcd_rect(0,45,57,62,0,1);
glcd_rect(0,34,12,45,0,1);
glcd_line(1,45,11,45,0);
glcd_circle(3,37,1,0,1);
glcd_text57(0, 37, derece , 1, ON);

digitbas( 2 , 2 , ekrankm, 2 );

rakambas2(77,9, ekrankm2,1);
glcd_line(74,1,74,16,1);
glcd_rect(0,0,127,17,0,1);
glcd_text57(121, 2, kmk , 1, ON);
glcd_text57(121, 9, kmm , 1, ON);
if(tripkmno==1) glcd_circle(82,2,2,1,1);
else glcd_circle(82,2,2,0,1);
if(tripkmno==2) glcd_circle(91,2,2,1,1);
else glcd_circle(91,2,2,0,1);
if(tripkmno==3) glcd_circle(100,2,2,1,1);
else glcd_circle(100,2,2,0,1);
if(tripkmno==4) glcd_circle(109,2,2,1,1);
else glcd_circle(109,2,2,0,1);
}
//-------------------------{}----------------------------

void dashcar(){


dash_avent(0,0);



      theta1 = 3.15 + (10.4*temperature)/100;
      if(theta1>7.85) theta1 = 7.85;   
      if(temperature < 0) theta1 = 3;         
      theta2 = 3.15 + (8.6*speed)/100;
      if(theta2>7.85) theta2 = 7.85;
      thetamax = 3.15 + (8.6*maxspeed)/100;
      if(thetamax>7.85) thetamax = 7.85;      
      //theta3 = hrs * 0.523;
     
      theta4 = 0.105 * min;
      theta3 = (hrs * 0.523) + (theta4 /12);

      glcd_line(20, 46, 20+(int)(11*sin(theta1)), 46-(int)(11*cos(theta1)), ON);      
      glcd_line(20, 47, 20+(int)(11*sin(theta1)), 47-(int)(11*cos(theta1)), ON);
      glcd_circle(20, 46,1,1,1);
      
      glcd_line(63, 29, 63+(int)(22*sin(theta2)), 29-(int)(22*cos(theta2)), ON);
      glcd_line(63, 30, 63+(int)(22*sin(theta2)), 30-(int)(22*cos(theta2)), ON);
      glcd_circle(63, 29,2,1,1);
      
      glcd_line(63+(int)(18*sin(thetamax)), 29-(int)(18*cos(thetamax)), 63+(int)(25*sin(thetamax)), 29-(int)(25*cos(thetamax)), ON);
      
      glcd_line(106, 46, 106+(int)(8*sin(theta3)), 46-(int)(8*cos(theta3)), ON);
      glcd_line(106, 47, 106+(int)(8*sin(theta3)), 47-(int)(8*cos(theta3)), ON);
      glcd_line(106, 46, 106+(int)(11*sin(theta4)), 46-(int)(11*cos(theta4)), ON);
      glcd_line(106, 47, 106+(int)(11*sin(theta4)), 47-(int)(11*cos(theta4)), ON);
      glcd_circle(106, 46,1,1,1);      
//ekrankm=999999.7;
      digitbas( 46 , 57 , ekrankm, 1 );
      //minisayi(51,59, ekrankm);
      //rakambas2(50,46, ekrankm2,1);
      rakambas( 58 , 33 , speed , 1 );
      
      saatbas( 98 , 0 , 1 );


      rakambas( 0 , 0 , temperature , 1 );
      if(tempsira==1) { tambas(18,19,maxtemp,1); glcd_line(18, 17, 28, 17, 1); tempsira=0;}
      else { tambas(18,19,mintemp,1); glcd_line(18, 27, 28, 27, 1); tempsira=1;}
      //minisayi2( 1 , 20 , temperature  );
      
      //digitbas( 47 , 15 , tripmins, 1 );
      //rakambas( 99 , 20 , avgspeed , 1 );
      tambas(99,20,avgspeed,1);
      tambas(110,25,tripmins,1);
      
        
}
//-------------------------{}----------------------------

void dashana(){

dashciz(0,0);


      theta1 = 3 + (8.6*temperature)/100;
      if(theta1>6.8) theta1 = 6.8;   
      if(temperature < 0) theta1 = 3;         
      theta2 = 4 + (8.6*speed)/100;
      if(theta2>8.6) theta2 = 8.6;
      thetamax = 4 + (8.6*maxspeed)/100;
      if(thetamax>8.6) thetamax = 8.6;      
      //theta3 = hrs * 0.523;
     
      theta4 = 0.105 * min;
      theta3 = (hrs * 0.523) + (theta4 /12);

      glcd_line(26, 31, 26+(int)(16*sin(theta1)), 31-(int)(16*cos(theta1)), ON);      
      glcd_line(26, 32, 26+(int)(16*sin(theta1)), 32-(int)(16*cos(theta1)), ON);
      glcd_circle(26, 31,2,1,1);
      
      glcd_line(64, 31, 64+(int)(25*sin(theta2)), 31-(int)(25*cos(theta2)), ON);
      glcd_line(64, 32, 64+(int)(25*sin(theta2)), 32-(int)(25*cos(theta2)), ON);
      glcd_circle(64, 31,2,1,1);
      
      glcd_line(64+(int)(18*sin(thetamax)), 31-(int)(18*cos(thetamax)), 64+(int)(25*sin(thetamax)), 31-(int)(25*cos(thetamax)), ON);
      
      glcd_line(106, 31, 106+(int)(10*sin(theta3)), 31-(int)(10*cos(theta3)), ON);
      glcd_line(106, 32, 106+(int)(10*sin(theta3)), 32-(int)(10*cos(theta3)), ON);
      glcd_line(106, 31, 106+(int)(15*sin(theta4)), 31-(int)(15*cos(theta4)), ON);
      glcd_line(106, 32, 106+(int)(15*sin(theta4)), 32-(int)(15*cos(theta4)), ON);
      glcd_circle(106, 31,2,1,1);      
//ekrankm=999999.7;
      digitbas( 47 , 57 , ekrankm, 1 );
      rakambas2(50,46, ekrankm2,1);
      rakambas( 50 , 38 , speed , 1 );
      
      saatbas( 89 , 57 , 1 );

      rakambas( 10 , 57 , temperature , 1 );
      
      digitbas( 47 , 15 , tripmins, 1 );
      rakambas( 45 , 6 , avgspeed , 1 );
      //tambas(0,0,batvolt,1);
}
//-------------------------{}----------------------------
void ilkacilis(){
int sayac;

   for(sayac=0;sayac<=55;sayac+=5){
   glcd_fillScreen(0);
   
   speed=sayac;
   temperature=sayac/1.2;
   hrs=sayac/5;
   min=sayac+5;
   if(ekrtip==0) dashana();
   if(ekrtip==1) dashdigi();
   if(ekrtip==2) dashcar();
   glcd_update();
   }
   for(sayac=55;sayac!=251;sayac-=5){
   glcd_fillScreen(0);
   
   speed=sayac;
   temperature=sayac/1.2;
   hrs=sayac/5;
   min=sayac+5;   
   if(ekrtip==0) dashana();
   if(ekrtip==1) dashdigi();
   if(ekrtip==2) dashcar();
   glcd_update();
   }
}
//-------------------------{}----------------------------
void ayar(){

int ayarmod;


ayarmod = 1;

ds1307_get_date(day,month,yr,dow); 
ds1307_get_time(hrs,min,sec); 


glcd_fillScreen(0);

while(modtusu);     

basadon:




//lcd_gotoxy(1,1);
//lcd_putc("AYAR :   ");
// ayarmodu : 1   2   3   4   5   6   7  
// ayarlanan: hrs min day mon yea dow T
 


glcd_fillScreen(0);   
saatbas( 26 , 2 , 3 );
dowbas( 105 , 28 , 2 );
tarihbas( 2 , 28 , 2 );
tekerbas( 25 , 48 , 2);





            


      switch(ayarmod){
            case 1:
               glcd_rect(24,0,58,24,0,1);
            break;
            case 2:
               glcd_rect(72,0,106,24,0,1);
            break;
            case 3:
               glcd_rect(0,26,24,43,0,1);                              
            break;
            case 4:
               glcd_rect(35,26,57,43,0,1);
            break;
            case 5:
               glcd_rect(66,26,90,43,0,1);
            break;
            case 6:
               glcd_rect(103,26,127,43,0,1);   
            break;
            case 7:
               glcd_rect(23,46,102,63,0,1);           
            break;
      }


glcd_update();

while (TRUE){

   if(modtusu) {
      beep(10);
   while(modtusu);
      ayarmod ++;
      if (ayarmod == 8 ) {
         
         ds1307_set_date_time(day,month,yr, dow,hrs,min,0); 
         glcd_fillScreen(0);
         glcd_update();
         tekercevyaz();
         return;
      }
      goto basadon;
   }
   if(arttusu) {
   beep(1);
   while (arttusu);
   
      switch(ayarmod){
            case 1:
               hrs ++;
               if ( hrs >= 24 ) hrs = 0;
            break;
            case 2:
               min ++;
               if ( min >= 60 ) min = 0;
            break;
            case 3:
               day ++;
               if ( day >= 32 ) day = 0;
            break;
            case 4:
               month ++;
               if ( month >= 13 ) month = 1;
            break;
            case 5:
               yr ++;
            break;
            case 6:
               dow ++;
               if ( dow >= 8 ) dow = 1;
            break;
            case 7:
               if ( tekercevresi  < 9999 ) tekercevresi++;              
            break;
      }
      goto basadon;
   }
   
   if(azttusu) {
   beep(1);
   while (azttusu);
   
      switch(ayarmod){
            case 1:
               hrs --;
               if ( hrs == 255 ) hrs = 23;
            break;
            case 2:
               min --;
               if ( min == 255 ) min = 59;
            break;
            case 3:
               day --;
               if ( day == 255 ) day = 31;
            break;
            case 4:
               month --;
               if ( month == 0 ) month = 12;
            break;
            case 5:
               yr --;
            break;
            case 6:
               dow --;
               if ( dow == 0 ) dow = 7;
            break;
            case 7:
               if ( tekercevresi  > 0 ) tekercevresi--;
            break;
      }
      goto basadon;
   }

}
}

//   main function               (main function of the program)
//==========================================================================
void main(void)
{

float frequency; 
int32 current_ccp_delta; 
int sleeptimer;


set_timer1(0);    
setup_timer_1(T1_INTERNAL | T1_DIV_BY_2);    
setup_ccp1(CCP_CAPTURE_RE);    


SETUP_ADC_PORTS(AN0);
setup_adc(ADC_CLOCK_INTERNAL); 
set_adc_channel(0);

SETUP_WDT(WDT_OFF);

printf("Start: OK\n\r");
//lcd_init();
//beep(2);

output_low(powcon);
beep(50);
glcd_init (ON);

if(restart_cause()==NORMAL_POWER_UP) {
   splashscreen(0,0);
   glcd_update ();
//   ilkacilis();
}
//delay_ms(1000);
   pulsevar=0;
   


ds1307_init(); 
  // Set date for -> 15 June 2005 Tuesday 
  // Set time for -> 15:20:55 

//ds1307_set_date_time(2,3,9,2,20,50,55); 

port_b_pullups(0b00111111);



toplamm = 0;

toplamm += read_eeprom( 0 );
toplamm=toplamm<<8;
toplamm += read_eeprom( 1 );
toplamm=toplamm<<8;
toplamm += read_eeprom( 2 );
toplamm=toplamm<<8;
toplamm += read_eeprom( 3 );

tripmm1 = 0;

tripmm1 += read_eeprom( 4 );
tripmm1=tripmm1<<8;
tripmm1 += read_eeprom( 5 );
tripmm1=tripmm1<<8;
tripmm1 += read_eeprom( 6 );
tripmm1=tripmm1<<8;
tripmm1 += read_eeprom( 7 );

tekercevresi = 0;  

tekercevresi += read_eeprom( 18 );
tekercevresi = tekercevresi << 8 ;
tekercevresi += read_eeprom( 20 );
tekercevresi = tekercevresi << 8 ;
tekercevresi += read_eeprom( 22 );
tekercevresi = tekercevresi << 8 ;
tekercevresi += read_eeprom( 24 );

ekrtip = read_eeprom( 30 );
if ( ekrtip >= 3 ) ekrtip = 0;
ekrtip = 2 ;

//toplamm=8888100000;
//tripmm1=88888888;

maxspeed = 0 ;
eskispeed = 0 ;
tripkmno=1;

tripmm2 = 0;
tripmm3 = 0;
tripmm4 = 0;

ilkokuma = 0;

tripmins = 255;

maxtemp = 0;
mintemp = 0;

temperature = 0;
eskitemp = 0;

sleeptimer=0;

// Enable interrupts. 
clear_interrupt(INT_TIMER1); 
enable_interrupts(INT_TIMER1); 

clear_interrupt(INT_CCP1); 
enable_interrupts(INT_CCP1); 

clear_interrupt(INT_EXT); 
enable_interrupts(INT_EXT);

enable_interrupts(GLOBAL); 



while(TRUE) 
{
//bekle(100);
 
 if ( pulsevar > 100 ) {
   speed=0;
   maxspeed=0;
   tripmins=0;
   tripmm1=0;
//   rakambas(38,20, speed,3);
//   glcd_update(); 
 }
 
 glcd_fillScreen(0);
 
 if(pulsegeldi)glcd_pixel(127,63,1);
 if( speed == 0) glcd_pixel(126,63,1); 
 if( speed > eskispeed) glcd_pixel(125,63,1);
 if(batvolt>=24)glcd_pixel(124,63,1);

//digitbas(0,20,123456,1);
 
  if(gc_capture_flag == TRUE) 
     {
      pulsevar = 0;
      disable_interrupts(GLOBAL); 
      current_ccp_delta = g32_ccp_delta;; 
      enable_interrupts(GLOBAL); 

      frequency =  ( 1000000L / (float)current_ccp_delta ); 
      speed = 3.6*2.3*frequency;
      
      if ( speed > 99 ) {
         beep (1);
         speed = eskispeed;
      }
      else eskispeed = speed;
      
      gc_capture_flag = FALSE; 
     }
  else 
    {
//      printf("No signal\n\r"); 
//      speed = 0;
     
//      rakambas(48,20, speed,3);
//      glcd_update();     
     
//      lcd_gotoxy(1,1);
//      lcdbas( 0 , 0);
    } 

if (speed > maxspeed ) maxspeed = speed;

//*********************************************

if(modtusu) { 
   beep(10);
   ayar();
   }

if(arttusu && azttusu ) {
   beep(10);
   tripmm1 = 0;
   while (arttusu && azttusu );
}

if(arttusu) {
   beep(2);
   if(tripkmno++==4) tripkmno=1;
}

if(azttusu) {
   beep(2);
   ekrtip++;
   if(ekrtip==3) ekrtip = 0;
   write_eeprom(30,ekrtip);
}


if (ekrankm != eskikm) {
   kmyaz();
   eskikm = ekrankm;
}


ekrankm = (float) toplamm / 1000000 ; 
//ekrankm2 = (float) tripmm1 / 1000000 ; 


      switch(tripkmno){
            case 1:
               ekrankm2 = (float) tripmm1 / 1000000 ; 
            break;
            case 2:
               ekrankm2 = (float) tripmm2 / 1000000 ; 
            break;
            case 3:
               ekrankm2 = (float) tripmm3 / 1000000 ; 
            break;
            case 4:
               ekrankm2 = (float) tripmm4 / 1000000 ; 
            break;
      }






   if(ekrtip==0) dashana();
   if(ekrtip==1) dashdigi();
   if(ekrtip==2) dashcar();

//lcd_gotoxy(15,2);

//ekrankm2 = tripkm/1000000;
//lcdbas( ekrankm2 , 0);
//rakambas(1,25, ekrankm2,2);*/
//printf("Toplam mm : %lu \r\n", toplamkm );

do{  
   temperature = ds1820_read();
}while( temperature >= 65 ) ;

//if ( temperature >= 65 && ilkokuma==1) temperature=eskitemp;

if (ilkokuma == 0) { maxtemp=temperature; mintemp=temperature;}

ilkokuma = 1;

   if ( temperature > maxtemp ) maxtemp = temperature;
   if ( temperature < mintemp ) mintemp = temperature;

     
if( temperature != eskitemp) {
//printf("Temp: %f\r", temperature);
eskitemp = temperature;
}
  
 
ds1307_get_date(day,month,yr,dow); 
ds1307_get_time(hrs,min,sec); 

if(min!=eskimin) {
   tripmins++;
   eskimin=min;
   avgspeed=(float) (ekrankm2*60/tripmins);
   if (speed == 0 ) sleeptimer++;
   if( sleeptimer == 6 ) {
      beep(150);
      output_low(GLCD_E);
      output_high(powcon);

      sleep();

      output_low(powcon);
      output_high(GLCD_E);
      speed=1;
      sleeptimer=0;
      beep(150);
   }
}
      
//printf("\f\%02d/\%02d/\%02d\r\n",day,month,yr); 
//printf("\%02d:\%02d:\%02d\r\n", hrs,min,sec); 
batvolt=read_Adc();
//printf("\%02d\r\n", batvolt);
//ekrankm = 1000000;
//printf("\%5.1f \r\n",  ekrankm);


glcd_update();
//sleep();

}
  
}









